﻿config(in,configXml) ::= <<
<!doctype html>
<html>
	<head>
		<title>LogoControl Configuration</title>
		<link rel="stylesheet" href="base.css">
		<link rel="stylesheet" href="codemirror.css">
		<script src="codemirror.js"></script>
		<style type="text/css">
		  .CodeMirror { border: 1px solid #aaa; height: auto; background-color: #f7f7f7;}
		  .CodeMirror-gutters { border-right: 1px solid #aaa; background-color: #d7d7d7; }
		  .CodeMirror-linenumber { color: #666; }
		  .CodeMirror-matchingtag { background: rgba(255, 150, 0, .3); }			
		  .CodeMirror-scroll { overflow-y: hidden; overflow-x: auto; }
		</style>
	</head>
	<body>
    <div class="header">
		<ul>
		  <li>
			<a href="index.st">Status</a>
		  </li>
		  <li>
			<a href="config.st" class="header-active">Konfiguration</a>
		  </li>
		</ul>
	</div>
    <br />
		<form action="config.st" method="post" enctype="multipart/form-data">
			<input type="button" id="saveButton" value="Save changes" onclick="saveConfig();">
			<input type="button" id="restartButton" value="Restart LogoControl" onclick="restart();">
        <span style="color:#FFFFFF; margin-left:20px">Tipp: Code-Vervollständigung mit Ctrl-Space nutzen!</span>
        <br /><br />
			<textarea id="code" name="code">$configXml$</textarea>
		</form>
		<script>
			document.addEventListener("keydown", function(e) {
			  if (e.keyCode == 83 && (navigator.platform.match("Mac") ? e.metaKey : e.ctrlKey)) {
				e.preventDefault();
				//Ignore Ctrl + S
			  }
			}, false);


		  function saveConfig()
		  {
			document.getElementById('saveButton').disabled = true; 
		    document.getElementById('restartButton').disabled = true; 
			var xmlHttp = getXmlHttpObject();
			if (xmlHttp) {
				xmlHttp.open('POST', 'config.st', true);
				xmlHttp.setRequestHeader('Content-type','text/plain; charset=UTF-8');
				xmlHttp.onreadystatechange = function () {
					if (xmlHttp.readyState == 4) {
						alert(xmlHttp.responseText);
						document.getElementById('saveButton').disabled = false;
						document.getElementById('restartButton').disabled = false; 
					}
				};
				xmlHttp.send(editor.getValue());
			}
		  }

		  function restart()
		  {
			document.getElementById('restartButton').disabled = true; 
			document.getElementById('saveButton').disabled = true;
			var xmlHttp = getXmlHttpObject();
			if (xmlHttp) {
				xmlHttp.open('GET', 'rest/restart', true);
				xmlHttp.onreadystatechange = function () {
					if (xmlHttp.readyState == 4) {
						alert('Restarting now!\nIf the webservice ports are still the same I will try to redirect you automatically...');
						window.location.replace("index.st");
					}
				};
				xmlHttp.send(null);
			}
		  }

		  function getXmlHttpObject()
		  {
			var xmlHttp = null;
			try {
				// Mozilla, Opera, Safari sowie Internet Explorer (ab v7)
				xmlHttp = new XMLHttpRequest();
			} catch(e) {
				try {
					// MS Internet Explorer (ab v6)
					xmlHttp  = new ActiveXObject("Microsoft.XMLHTTP");
				} catch(e) {
					try {
						// MS Internet Explorer (ab v5)
						xmlHttp  = new ActiveXObject("Msxml2.XMLHTTP");
					} catch(e) {
						xmlHttp  = null;
					}
				}
			}
			return xmlHttp;
		  }
		  
		  		  var tags = {
			"!top": ["configuration"],
			configuration: {
			  attrs: null,
			  children: ["settings", "infrastructure"]
			},
			settings: {
			  attrs: null,
			  children: ["logo", "tcpService", "httpWebservice", "httpsWebservice"]
			},
				logo: {
				  attrs: {
					ip: null
				  },
				  children: []
				},
				tcpService: {
				  attrs: {
					port: ["55000"]
				  },
				  children: []
				},
				httpWebservice: {
				  attrs: {
					port: ["8088"]
				  },
				  children: []
				},
				httpsWebservice: {
				  attrs: {
					port: ["8080"],
					username: null,
					passwordHash: null,
					hashSalt: null
				  },
				  children: []
				},
			infrastructure: {
			  attrs: null,
			  children: ["group"]
			},
			group: {
			  attrs: {name: null},
			  children: ["group", "device"]
			},
			device: {
			  attrs: {
			    id: null,
			    name: null,
				type: ["light", "shutter", "custom"]
			  },
			  children: ["attribute", "method", "trigger"]
			},
					attribute: {
					  attrs: {
						id: null,
						name: null,
						address: null,
						datatype: ["bit", "byte", "word", "dword", "uword"],
						gain: null,
						offset: null
					  },
					  children: ["valuetext"]
					},
						valuetext: {
						  attrs: {
							value: null,
							text: null
						  },
						  children: []
						},
					method: {
					  attrs: {
						id: null,
						name: null,
						address: null,
						url: null,
						script: null
					  },
					  children: []
					},
					trigger: {
					  attrs: {
						address: null,
						datatype: ["bit", "byte", "word", "dword"]
					  },
					  children: ["onValue"]
					},		
						onValue: {
						  attrs: {
							value: null,
							method: null
						  },
						  children: []
						}
		  };

		  function completeAfter(cm, pred) {
			var cur = cm.getCursor();
			if (!pred || pred()) setTimeout(function() {
			  if (!cm.state.completionActive)
				CodeMirror.showHint(cm, CodeMirror.hint.xml, {schemaInfo: tags, completeSingle: false});
			}, 100);
			return CodeMirror.Pass;
		  }

		  function completeIfAfterLt(cm) {
			return completeAfter(cm, function() {
			  var cur = cm.getCursor();
			  return cm.getRange(CodeMirror.Pos(cur.line, cur.ch - 1), cur) == "<";
			});
		  }

		  function completeIfInTag(cm) {
			return completeAfter(cm, function() {
			  var tok = cm.getTokenAt(cm.getCursor());
			  if (tok.type == "string" && (!/['"]/.test(tok.string.charAt(tok.string.length - 1)) || tok.string.length == 1)) return false;
			  var inner = CodeMirror.innerMode(cm.getMode(), tok.state).state;
			  return inner.tagName;
			});
		  }

		  var editor = CodeMirror.fromTextArea(document.getElementById("code"), {
			mode: "xml",
			lineNumbers: true,
			styleActiveLine: true,
			viewportMargin: Infinity,
			indentUnit: 4,
			smartIndent: true,
			indentWithTabs: true,
			autoCloseTags: true,
			matchTags: {bothTags: true},
			foldGutter: true,
			gutters: ["CodeMirror-linenumbers", "CodeMirror-foldgutter"],
			extraKeys: {
			  "'<'": completeAfter,
			  "'/'": completeIfAfterLt,
			  "' '": completeIfInTag,
			  "'='": completeIfInTag,
			  "Ctrl-Space": function(cm) {
				CodeMirror.showHint(cm, CodeMirror.hint.xml, {schemaInfo: tags});
			  }
			}
		  });
		</script>
	</body>
</html>
>>